<?php	session_start();
	include_once("../kernel.php");
	if(!isset($_SESSION['user_id']))
                die(lang_fa_class::access_deny);
        $se = security_class::auth((int)$_SESSION['user_id']);
        if(!$se->can_view || !$conf->anbar)
                die(lang_fa_class::access_deny);
	function delete_item($id)
	{
		mysql_class::ex_sqlx("update `anbar_det` set `en`=0 where `id` = $id");
	}
	function loadKala()
	{
		$out = null;
		mysql_class::ex_sql('select `name`,`code`,`id`,`vahed_id` from `kala` order by `name`',$q);
		while($r = mysql_fetch_array($q))
		{
			$vahed = new kala_vahed_class((int)$r['vahed_id']);
			$out[$r['name'].' ('.$r['code'].')'.'['.$vahed->name.']'] = (int)$r['id'];
		}
		return($out);
	}
	function loadAnbar($anbar_id)
	{
		$out = '<select class="inp" name="anbar_id" id="anbar_id" onchange="document.getElementById(\'frm1\').submit();" ><option value=""></option>';
		mysql_class::ex_sql('select `name`,`id` from `anbar` where `en`<>2 order by `name`',$q);
		while($r = mysql_fetch_array($q))
		{
			$sel = ($r['id']==$anbar_id)?'selected="selected"':'';
			$out.= "<option $sel value='".$r['id']."' >".$r['name']."</option>\n";
		}
		$out .='</select>';
		return($out);
	}
	function loadUser()
	{
		$out = null;
		mysql_class::ex_sql('select `fname`,`lname`,`id` from `user` order by `lname`',$q);
		while($r = mysql_fetch_array($q))
		{
			$out[$r['lname'].' '.$r['fname']] = (int)$r['id'];
		}
		return($out);
	}

	function loadTyp()
	{
		$out = null;
		$abnar_typ_id = -1;
		if(isset($_REQUEST['anbar_typ_id']))
			$abnar_typ_id = (int)$_REQUEST['anbar_typ_id'];
		mysql_class::ex_sql("select `name`,`id` from `anbar_typ` where `id`=$abnar_typ_id order by `name`",$q);
		while($r = mysql_fetch_array($q))
		{
			$out[$r['name']] = (int)$r['id'];
		}
		return($out);
	}
	function hpdate($inp)
	{
		return(audit_class::hamed_pdate($inp));
	}
	function hpdateback($inp)
	{
		return(audit_class::hamed_pdateBack(perToEnNums($inp)));
	}
	function edit_item($id,$feild,$value)
	{
		if($feild=='ghimat' || $feild=='tedad')
		{
			$anbar_factor_id = new anbar_det_class($id);
			$anbar_factor_id = $anbar_factor_id->anbar_factor_id;
			mysql_class::ex_sqlx("update `anbar_det` set `en`='0' where `anbar_factor_id` = $anbar_factor_id");
		}
		if($feild=='tarikh')
			$value = audit_class::hamed_pdateBack(perToEnNums($value));
		mysql_class::ex_sqlx("update `anbar_det` set `$feild`='$value' where `id`=$id ");
	}
	function add_item()
	{
		$fields = null;
                foreach($_REQUEST as $key => $value)
                        if(substr($key,0,4)=='new_')
                                if($key != 'new_id' && $key != 'new_moeen_id' && $key != 'new_en' && $key != 'new_tedad_kh' )
                                        $fields[substr($key,4)] =perToEnNums($value);
		$anbar_type = new anbar_typ_class($_REQUEST['anbar_typ_id']);
		$fields['tarikh'] = audit_class::hamed_pdateBack(perToEnNums($fields['tarikh']));
		$fields['tedad'] = abs((int)$fields['tedad']);
		$fields['user_id'] = (int)$_SESSION['user_id'];
		$fields['anbar_id'] = ((isset($_REQUEST['anbar_id']))?(int)$_REQUEST['anbar_id']:-1);
		$fields['anbar_factor_id'] = ((isset($_REQUEST['anbar_factor_id']))?(int)$_REQUEST['anbar_factor_id']:-1);
		$query = '';
                $fi = "(";
	        $valu="(";
		$bool = TRUE;
		foreach ($fields as $field => $value)
        	{
		        $fi.="`$field`,";
                        $valu .="'$value',";
			if($anbar_type->typ==-1 && $field!='ghimat' && $value=='') 
				$bool = FALSE;
                }
		
       		$fi=substr($fi,0,-1);
                $valu=substr($valu,0,-1);
		$fi.=")";
        	$valu.=")";
		$query.="insert into `anbar_det` $fi values $valu";
		if($anbar_type->typ==1)
			$fields['ghimat'] = abs((int)$fields['ghimat']);
		else if($anbar_type->typ==-1)
			$fields['ghimat'] = anbar_det_class::calcGhimat($fields['kala_id'],$fields['tedad'],FALSE);
		if($bool)
			if($fields['tedad']>0)
				if($fields['ghimat']>0)
					if($fields['anbar_id']>0)
						if($fields['anbar_factor_id']>0)
							if($anbar_type->typ==-1)
							{
								$fields['ghimat'] = anbar_det_class::calcGhimat($fields['kala_id'],$fields['tedad'],TRUE);
								anbar_det_class::khorooj($fields['anbar_id'],$anbar_type->id,$fields['anbar_factor_id'],$fields['kala_id'],$fields['tedad'],$fields['user_id'],$fields['other_user_id'],$fields['ghimat'],$fields['tarikh']);
							}
							else if($anbar_type->typ==1)
								mysql_class::ex_sqlx($query);
						else
							echo 'شماره فاکتور درست وارد نشده است';
					else
						echo 'انبار انتخاب نشده است';
				else
					echo 'موجودی انبار کافی نیست';
			else
				echo 'تعداد کالا درست وارد نشده است';
		else
			echo '<center>تمامی موارد اطلاعات را وارد کنید</center>';
		
		
	}
	function loadDet($inp)
	{
		$jozeeat ="چاپ";
		 $out = "<u><span style=\"color:Blue;cursor:pointer;\" onclick=\"wopen('jozeeat_kala.php?sel_id=$inp&','',900,300);\">$jozeeat</span></u>";
		return $out;
	}
	//-----------g پردازش مربوط به ثبت نهایی
	if (isset($_REQUEST["access_mod"]) && ($_REQUEST["access_mod"]==1))
	{
		$access_mod = $_REQUEST["access_mod"];
	}
	else
	{
		$access_mod = 0;
	}
	if ($access_mod == 1)
	{
		$factor_id = (isset($_REQUEST["factor_id"]))?$_REQUEST["factor_id"]:0;
		if($factor_id >0)
		{
			$anbar_ids = anbar_det_class::loadByFactorId($factor_id);
			sanadzan_class::deleteAnbarSabt($factor_id);
			for($i = 0; $i<count($anbar_ids);$i++)
			{
				$anbar_type = new anbar_typ_class($anbar_ids[$i]->anbar_typ_id);
				$moshtari_moeen_id = new anbar_factor_class($factor_id);
				$moshtari_moeen_id = $moshtari_moeen_id->moeen_id; 
				$anbar_moeen_id = new anbar_class($anbar_ids[$i]->anbar_id);
				$anbar_moeen_id = $anbar_moeen_id->moeen_id;
				$sanad_rec = sanadzan_class::anbarSabt($factor_id,$anbar_ids[$i]->kala_id,$anbar_type->typ,$anbar_ids[$i]->anbar_id,$anbar_ids[$i]->tedad,$anbar_ids[$i]->ghimat,$moshtari_moeen_id,$anbar_moeen_id,$anbar_ids[$i]->user_id);
				if($sanad_rec[0]>0)
					mysql_class::ex_sqlx("insert into `sanad_anbar` (`sanad_record_id`,`anbar_factor_id`) values ('".$sanad_rec[0]."','$factor_id')");
			}
			mysql_class::ex_sqlx("update `anbar_det` set `en`='1' where `anbar_factor_id` = $factor_id");
			mysql_class::ex_sql("select *,sum(`ghimat`) as `gheimat_kol` from `anbar_det` where `anbar_factor_id` = $factor_id",$q);
		        if($r = mysql_fetch_array($q))
			{
				$anbar_factor_id=$r["anbar_factor_id"];
				$gheimat = $r["gheimat_kol"];
				$anbar_typ_id = $r["anbar_typ_id"];
			
			}
	//		echo $factor_id."<br/>".$gheimat."<br/>".$anbar_typ_id."<br/>".$_SESSION['user_id'];
			$sanad_rec = sanadzan_class::anbarSabtTak($factor_id,$gheimat,$anbar_typ_id,$_SESSION['user_id']);
			if($sanad_rec[0]>0)
				mysql_class::ex_sqlx("insert into `sanad_anbar` (`sanad_record_id`,`anbar_factor_id`) values ('".$sanad_rec[0]."','$factor_id')");
			$show = FALSE;
		}
	}
	//-------------g پایان پردازش مربوط به ثبت نهایی
	if(isset($_REQUEST['anbar_typ_id']) && $_REQUEST['anbar_typ_id']>0)
	{
		$anbar_type = new anbar_typ_class($_REQUEST['anbar_typ_id']);
		$msg = ' رسید ' .$anbar_type->name;
	}
	$anbar_factor_id = -1;
	$anbar_id_def = '';
	mysql_class::ex_sql("select `id` from `anbar` where `en`=1 order by `id` limit 1",$qq);
	if($r = mysql_fetch_array($qq))
		$anbar_id_def = $r['id'];
	$anbar_id = (isset($_REQUEST['anbar_id']))?$_REQUEST['anbar_id']:$anbar_id_def;
	$tmp_anbar_id = ($anbar_id=='')?-2:$anbar_id;
	if(isset($_REQUEST['anbar_factor_id']))
                $anbar_factor_id = (int)$_REQUEST['anbar_factor_id'];
	$grid = new jshowGrid_new("anbar_det","grid1");
	$grid->whereClause="anbar_factor_id=$anbar_factor_id and `anbar_id`=$tmp_anbar_id order by `tarikh`,`kala_id`";
	$grid->setERequest(array('anbar_id'=>$anbar_id));
	$grid->width = '95%';
	$grid->index_width = '20px';
	$grid->columnHeaders[0] = null;
        $grid->columnHeaders[1] = "کالا";
	$grid->columnLists[1] = loadKala();
	$grid->columnHeaders[2] = "تاریخ";
        $grid->columnFunctions[2] = "hpdate";
        $grid->columnCallBackFunctions[2] = "hpdateback";
	$grid->columnHeaders[3] = null;
	$grid->columnHeaders[4] = "تعداد";
	$grid->columnHeaders[5] = 'قیمت کل';
	$grid->columnHeaders[6] = 'تحویل دهنده';
	$grid->columnLists[6] = loadUser();
	$grid->columnHeaders[7] = null;
	$grid->columnHeaders[8] = "ورودی/خروجی";
	$grid->columnLists[8] =loadtyp();
	$grid->columnAccesses[8] = 0;
	$grid->columnHeaders[9] = null;
	$grid->columnHeaders[10] = null;
	$grid->columnHeaders[11] = null;
	mysql_class::ex_sql("select `anbar_factor_id`,`en`,sum(`ghimat`) as jam from `anbar_det` where `anbar_factor_id`=$anbar_factor_id and `anbar_id`=$tmp_anbar_id",$qu);
        if($row = mysql_fetch_array($qu))
        {
		if ((int)$row["en"]==1)
		{
			$grid->canAdd = FALSE;
			$grid->canEdit = FALSE;
			$grid->canDelete = FALSE;
			$jam = $row["jam"];
			$grid->footer = "<tr class='showgrid_insert_row'  ><td colspan='4' >&nbsp;</td><td>جمع قیمت کل:$jam</td><td>&nbsp;</td><td>&nbsp;</td></tr>";
		}
        }
	if(anbar_factor_class::isJaari($row['anbar_factor_id']))
		$grid->canEdit = TRUE;
	$grid->editFunction = 'edit_item';
	$grid->canDelete = FALSE;
	$grid->addFunction = 'add_item';
        $grid->intial();
   	$grid->executeQuery();
	$show = FALSE;
	if ($tmp_anbar_id != -2)
		$show = TRUE;
	mysql_class::ex_sql("select `en` from `anbar_det` where `anbar_factor_id`=$anbar_factor_id and `anbar_id`=$tmp_anbar_id",$q);
        while($r = mysql_fetch_array($q))
	{
		((int)$r["en"]==1)?$show=FALSE:$show = $show && TRUE;
	}
        $out = $grid->getGrid();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<!-- Style Includes -->
		<link type="text/css" href="../js/jquery/themes/trontastic/jquery-ui.css" rel="stylesheet" />
		<link type="text/css" href="../js/jquery/window/css/jquery.window.css" rel="stylesheet" />

		<link type="text/css" href="../css/style.css" rel="stylesheet" />

		<!-- JavaScript Includes -->
		<script type="text/javascript" src="../js/jquery/jquery.js"></script>
		<script type="text/javascript" src="../js/tavanir.js"></script>
		<script type="text/javascript" src="../js/jquery/jquery-ui.js"></script>
		<script>
			function send_frm()
        	        {
                	        document.getElementById('mod_button').style.display = "none";
				document.getElementById('access_mod').value = "1";
                        	document.getElementById('frm1').submit();
	                }	
		</script>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>
		</title>
	</head>
	<body>
		<?php echo security_class::blockIfBlocked($se,lang_fa_class::block); ?>
		<div align="center">
			<br/>
			<form method='post' id="frm1" >
				<?php echo '<b>'.$msg.'</b>'.loadAnbar($anbar_id) ?>
				<input type="hidden" value="0" name="access_mod" id="access_mod" class="inp" >
				<input type="hidden" value="<?php echo $anbar_factor_id;?>" name="factor_id" id="factor_id" class="inp" >
				
                        </form>

			<br/>
			<?php	
		//		echo $out;
			?>
			<input type="button" value="ثبت نهایی" id ="mod_button" class="inp" style="display:<?php echo ($show)?'':'none';?>" onclick="send_frm();">	
			<br/>
			<br/>
			<?php   
                                echo $out;
                        ?>

		</div>
		<script language="javascript" >
		<?php
			if($anbar_type->typ == -1)
				echo "if(document.getElementById('new_ghimat'))\n document.getElementById('new_ghimat').style.display = 'none';";
		 ?>
		var inps = document.getElementsByTagName('input');
		var element;
		for(var i=0;i<inps.length;i++)
		{
			element = inps[i].id.split('_');
			if(element[0]=='new' && element[1]=='id')
				inps[i].style.display = 'none';
		}
		</script>
	</body>
</html>
